(* 
    File:  /tilco/Inteval.thy
    Theoy Name: Inteval
    Logic Image: tilco
*)

Interval  =  IntegBin +
constdefs
  single      :: int => int set        
     "single(t)  == {t}"

  nil         :: int set          
     "nil        == {}"

  open_open   :: [int, int] => int set                   ("<_,_>")
     "<a,b>      == {x. zsuc a <= x  & x <= zpred b}"

  open_close  :: [int, int] => int set                   ("<_,_]")
     "<a,b]      == {x. zsuc a <= x  & x <= b}"

  close_open  :: [int, int] => int set                   ("[_,_>")
     "[a,b>      == {x. a <= x & x <= zpred b}"

  close_close :: [int, int] => int set                   ("[_,_]")
     "[a,b]      == {x. a <= x & x <= b}"

  inf_inf     :: int set                                 ("<-inf,inf>")
     "<-inf,inf> == {x. True}"

  inf_close   :: int => int set                          ("<-inf,_]")
     "<-inf,b]   == {x. x <= b}"

  inf_open    :: int => int set                          ("<-inf,_>")
     "<-inf,b>   == {x. x <= zpred b}"

  close_inf   :: int => int set                          ("[_,inf>")
     "[a,inf>    == {x. a <= x}"

  open_inf    :: int => int set                          ("<_,inf>")
     "<a,inf>    == {x. zsuc a <= x}"  

end
